#include <cstdio>
#include <cstring>
#include <set>
#include <vector>
#include <algorithm>
using namespace std;

int n = 0, k, a[1024];
int ans;

set< vector<int> > sv;
vector<int> vec;

void printvec(vector<int> v)
{
	for (int i = 0; i < (int) v.size(); i++)
	{
		printf("%d ", v[i]);
	}
	printf("\n");
}

vector<int> tail(vector<int> a)
{
	vector<int> res;
	for (int i = 1; i < (int) a.size(); i++)
		res.push_back(a[i]);
	return res;
}

vector<int> rot(vector<int> a)
{
	vector<int> ret = tail(a);
	ret.push_back(a.front());
	return ret;
}

void fill_in(vector<int> beg)
{
	for (int i = 0; i < n; i++)
	{
		sv.insert(beg);
		beg = rot(beg);
	}
	reverse(beg.begin(), beg.end());
	for (int i = 0; i < n; i++)
	{
		sv.insert(beg);
		beg = rot(beg);
	}
}

void rec()
{
	if ((int) vec.size() >= n)
	{
		if (sv.find(vec) == sv.end())
		{
			++ans;
			fill_in(vec);
		}
		return;
	}
	for (int i = 0; i < k; i++)
	{
		if (a[i])
		{
			--a[i];
			vec.push_back(i);
			rec();
			vec.pop_back();
			++a[i];
		}
	}
}

int main()
{
	scanf("%d", &k);
	for (int i = 0; i < k; i++)
	{
		scanf("%d", &a[i]);
		n += a[i];
	}
	
	ans = 0;
	rec();
	
	printf("%d\n", ans);
	return 0;
}
